﻿/*
CSA Actions
$URL: https://svn.rsm.cloud/repos/NonClient/CSA_iPart/trunk/CSA/resources/CSA.ActionService.js $
$Rev: 14930 $
$Date: 2020-03-05 14:39:08 -0600 (Thu, 05 Mar 2020) $
*/

(function (CSA) {
	/* Adjust this constant to control time before messages disappear */
	var messageTimeout = 5000;
	var actionInProgress = 0;
	var redirectTo = "";

    function doRedirect() {
        if (redirectTo !== "") {
            if (redirectTo === window.location.href) {
                window.location.reload();
            }
            else {
                window.location.href = redirectTo;
            }
        }
        actionInProgress = 0;
    }

    function doMessage(s) {
		jQuery.jGrowl(s, { life: messageTimeout });
	}

	CSA.choices_onClick = function (e) {
        if (e.stopPropagation)
        {
            e.stopPropagation();
        } else {
            e.returnValue = false;
        }
		// Enable action button in alert body
		jQuery.each(jQuery(e).closest('.Alert').find('.action'), function (i, val) {
			val.disabled = false;
        });

		// Enable action button on zoom window
        jQuery.each(jQuery(e).closest('.Alert').next('.reveal-modal.zoom').find('.action'),
            function(i, val) {
                val.disabled = false;
            });
    }

	CSA.doZoom = function (e, obj) {
		if (e.stopPropagation)
		{
			e.stopPropagation();
		} else {
			e.returnValue = false;
		}
        jQuery(obj).closest('.Alert').next('.reveal-modal.zoom').each(
            function() {
                jQuery(this).reveal();
            });
    };

	CSA.doConfirm = function (e, obj) {
		if (e.stopPropagation)
		{
			e.stopPropagation();
		} else {
			e.returnValue = false;
		}
		jQuery(obj).closest('.Alert').next('.reveal-modal.zoom').next('.reveal-modal.csaConfirm').each(
			function () {
				jQuery(this).reveal();
			});
	};

	CSA.doAction = function (e, m, url) {
		if (e.stopPropagation)
		{
			e.stopPropagation();
		} else {
			e.returnValue = false;
		}
		if (actionInProgress === 1) {
			doMessage("Please wait for your previous action to complete.");
			return false;
		}
		actionInProgress = 1;
		redirectTo = "";

		var choicesSelectedValue = -1;
		var currentTarget = document.getElementById(e.currentTarget.id);
		var choicesListContainer = jQuery(currentTarget).closest('.Alert').find('.alertChoices').attr('id');
		var choicesList = document.getElementById(choicesListContainer);
		if (choicesList) {
			var choicesOptions = choicesList.getElementsByTagName("input");
			if (choicesOptions) {
				for (var inputCounter = 0; inputCounter < choicesOptions.length; inputCounter++) {
					if (choicesOptions[inputCounter].checked) {
						choicesSelectedValue = choicesOptions[inputCounter].value;
						break;
					}
				}
			}
		}

		jQuery.ajax({
			type: "POST",
			url: url + "/DoAction",
			data: JSON.stringify({ "m": m, "c": choicesSelectedValue }),
			dataType: "json",
			contentType: "application/json; charset=utf-8"
		}).done(function (msg) {
			if (msg.DoActionResult) {
				if (msg.DoActionResult.Status && msg.DoActionResult.Status === 1) {

					if (msg.DoActionResult.Script && msg.DoActionResult.Script.length > 0) {
						try {
							actionInProgress = 0;
							jQuery('.close-reveal-modal').click();
							var jsOutcome = eval(msg.DoActionResult.Script);
						} catch (err) {
							doMessage("An unrecognized error occurred<br/>performing your Javascript action.");
						}
						return;
					}

					var hasMessage = 0;

					if (msg.DoActionResult.Message && msg.DoActionResult.Message.length > 0) {
						doMessage(msg.DoActionResult.Message);
						hasMessage = 1;
					}

					if (msg.DoActionResult.Link && msg.DoActionResult.Link.length > 0) {
						redirectTo = msg.DoActionResult.Link;
					}
					else if (msg.DoActionResult.Reload === true) {
						redirectTo = window.location.href;
					}

					if (hasMessage === 1) {
						setTimeout(doRedirect, messageTimeout);
					}
					else {
						doRedirect();
					}
				}
				else {
					if (msg.DoActionResult.Message && msg.DoActionResult.Message.length > 0) {
						doMessage(msg.DoActionResult.Message);
					}
					else {
						doMessage("An unrecognized error occurred<br/>performing your action.");
					}
					actionInProgress = 0;
				}
			}
		}).fail(function (jqXHR, textStatus, errorThrown) {
			doMessage(errorThrown);
			actionInProgress = 0;
		});
		jQuery('.close-reveal-modal').click();
        return false;
    };
} (window.CSA = window.CSA || {}));
